#include <stdio.h> 
#include <sys/stat.h> 
#include "mies/SerialES/global.h"

#include "MOTestFunctions.h"
#include "WDN.h"

#ifdef MIES
#include "mies/SerialES/TestFunctions_MIES.h"
#include "WDN_MIES.h"
#endif

extern "C" 
{
#include "nsga2-v1.1/global.h"
#include "nsga2-v1.1/rand.h"
}

#define SNAPSHOTS     "generate_snap_shots"
#define REPORT_WINDOW 50 // Number of generations progress is reported for 

/* Real operator settings */
#define P_CROSS_R  0.8 
#define DIST_IDX_C 15 // 5-20
#define DIST_IDX_M 20 // 5-50

/* Binary operator settings */
#define P_CROSS_B  0.8

/* Nominal operator settings */
#define P_CROSS_N  0.8

// Mutation probability is 1/n for all types

/* Population memory allocation */
void allocateMemoryPop(population* P, int size); // Function to allocate memory to a population 
void allocateMemoryInd(individual* ind); // Function to allocate memory to an individual 
void deallocateMemoryPop(population* P, int size); // Function to deallocate memory to a population 
void deallocateMemoryInd(individual* ind); // Function to deallocate memory to an individual 

/* Wrapper function to execute MOTestFunctions and WDN member functions from the Deb C nsga2-v1.1 code */
void simulatorWrapper(double* xreal, double* xbin, int** gene, int* xnom, double* obj, double* constr);

/* Log time that was needed to complete generation */
void writeLog(double id, time_t elapsed, int currGen, bool feedback);


